<?php

namespace App\Service\Scraper;

use App\Entity\Chapter;
use App\Entity\ContentSource;

class MangaScraperService
{
    private ScraperFactory $scraperFactory;

    public function __construct(ScraperFactory $scraperFactory)
    {
        $this->scraperFactory = $scraperFactory;
    }

    public function scrapeChapter(Chapter $chapter, ContentSource $contentSource): array|bool
    {
        $scraper = $this->scraperFactory->createScraper($contentSource);
        return $scraper->scrapeChapter($chapter, $contentSource);
    }

    public function testScraping(string $mangaSlug, string $chapterNumber, ContentSource $contentSource): array
    {
        $scraper = $this->scraperFactory->createScraper($contentSource);
        return $scraper->testScraping($mangaSlug, $chapterNumber, $contentSource);
    }
}
